;
; Patched firmware version 278.07 based on factory firmware version 78.07 for the Axpert Max E 11kW Twin '28066.
; Attempts to implement all of Georg594's 90.06 patches.
; Also fixes the premature float bug and changes the version number.

				.tab		4
				.include	../PatchingMacrosTMS320C28x.inc
				.include	dsp_original_78.07.inc	; Include all the symbols
				.global		_c_int00				; Avoid "entry-point symbol undefined"

; Patch location 0: Fix the premature float bug. Replaces a branch if LO.
				inplace	floatBug, 1
				sb		$+4,HIS					; Change branch if lower to branch if higher or same


; Patch location 1. Replace a MOV AL,#9 with a mov AL,#39 to change the version number from 91.70 to 391.70:
				inplace	qvfwMajor, 2			; At this address for 2 words:
_c_int00:
				nop
				movb	AL, #27					; First digits of 00278.07

; Patch location 2: Change the MPPT charge current threshold from 0.50A to 0.05A. Replaces a CMP AL,#50
				inplace	mc1Current, 1
				cmp		AL, #05

; Patch location 3: Change the minimum MPPTvoltage with constant 200.0V. Replaces a call to _swGetEEPVMPPTLowLoss .
				inplace	mc1MpptMin, 2
				mov		AL, #2000
				inplace	mc1MpptMin+4, 2
				mov		AL, #2000

; Patch location 4: Change a compare 200 use 13 to a compare 35 use 4
				inplace	mc1Cmp200, 3
				cmpb    AL,#35									; Was #200
				sb      $+3,HIS									; Unchanged
				movb    AL,#4									; Was #13

; Patch locations 5-7: Same as above for MPPT2:

; Patch location 5: Change the MPPT charge current threshold from 0.50A to 0.05A. Replaces a CMP AL,#50
				inplace	mc2Current, 1
				cmp		AL, #05

; Patch location 6: Change the minimum MPPTvoltage with constant 200.0V. Replaces a call to _swGetEEPVMPPTLowLoss .
				inplace	mc2MpptMin, 2
				mov		AL, #2000
				inplace	mc2MpptMin+4, 2
				mov		AL, #2000

; Patch location 7 : Change a compare 200 use 13 to a compare 35 use 4
				inplace	mc2Cmp200, 3
				cmpb    AL,#35									; Was #200
				sb      $+3,HIS									; Unchanged
				movb    AL,#4									; Was #13


; Patch locations 8,9: Replace a compare and add in _sSetBoost1CtrlSts
				inplace	sb1csCmp, 1
				cmpb    AL,#10									; Was cmpb    AL,#200

				inplace	sb1csCmp+5, 1
				addb    AL,#0									; Was addb    AL,#-100

; Patch locations 10,11: Replace a compare and add in _sSetBoost2CtrlSts
				inplace	sb2csCmp, 1
				cmpb    AL,#10									; Was cmpb    AL,#200

				inplace	sb2csCmp+5, 1
				addb    AL,#0									; Was addb    AL,#-100


				.end
